## Channel Call content interfaces

Channel Call content interfaces — client-side wrappers for call contents

## Functions

TpProxyPendingCall * | tp_cli_call_content_call_remove ()
void | (*tp_cli_call_content_callback_for_remove) ()
TpProxySignalConnection * | tp_cli_call_content_connect_to_streams_added ()
TpProxySignalConnection * | tp_cli_call_content_connect_to_streams_removed ()
void | (*tp_cli_call_content_signal_callback_streams_added) ()
void | (*tp_cli_call_content_signal_callback_streams_removed) ()
TpProxyPendingCall * | tp_cli_call_content_interface_media_call_acknowledge_dtmf_change ()
TpProxyPendingCall * | tp_cli_call_content_interface_media_call_fail ()
TpProxyPendingCall * | tp_cli_call_content_interface_media_call_update_local_media_description ()
void | (*tp_cli_call_content_interface_media_callback_for_acknowledge_dtmf_change) ()
void | (*tp_cli_call_content_interface_media_callback_for_fail) ()
void | (*tp_cli_call_content_interface_media_callback_for_update_local_media_description) ()
TpProxySignalConnection * | tp_cli_call_content_interface_media_connect_to_dtmf_change_requested ()
TpProxySignalConnection * | tp_cli_call_content_interface_media_connect_to_local_media_description_changed ()
TpProxySignalConnection * | tp_cli_call_content_interface_media_connect_to_media_description_offer_done ()
TpProxySignalConnection * | tp_cli_call_content_interface_media_connect_to_media_descriptions_removed ()
TpProxySignalConnection * | tp_cli_call_content_interface_media_connect_to_new_media_description_offer ()
TpProxySignalConnection * | tp_cli_call_content_interface_media_connect_to_remote_media_descriptions_changed ()
void | (*tp_cli_call_content_interface_media_signal_callback_dtmf_change_requested) ()
void | (*tp_cli_call_content_interface_media_signal_callback_local_media_description_changed) ()
void | (*tp_cli_call_content_interface_media_signal_callback_media_description_offer_done) ()
void | (*tp_cli_call_content_interface_media_signal_callback_media_descriptions_removed) ()
void | (*tp_cli_call_content_interface_media_signal_callback_new_media_description_offer) ()
void | (*tp_cli_call_content_interface_media_signal_callback_remote_media_descriptions_changed) ()
TpProxySignalConnection * | tp_cli_call_content_interface_video_control_connect_to_bitrate_changed ()
TpProxySignalConnection * | tp_cli_call_content_interface_video_control_connect_to_framerate_changed ()
TpProxySignalConnection * | tp_cli_call_content_interface_video_control_connect_to_key_frame_requested ()
TpProxySignalConnection * | tp_cli_call_content_interface_video_control_connect_to_mtu_changed ()
TpProxySignalConnection * | tp_cli_call_content_interface_video_control_connect_to_video_resolution_changed ()
void | (*tp_cli_call_content_interface_video_control_signal_callback_bitrate_changed) ()
void | (*tp_cli_call_content_interface_video_control_signal_callback_framerate_changed) ()
void | (*tp_cli_call_content_interface_video_control_signal_callback_key_frame_requested) ()
void | (*tp_cli_call_content_interface_video_control_signal_callback_mtu_changed) ()
void | (*tp_cli_call_content_interface_video_control_signal_callback_video_resolution_changed) ()
TpProxyPendingCall * | tp_cli_call_content_interface_audio_control_call_report_input_volume ()
TpProxyPendingCall * | tp_cli_call_content_interface_audio_control_call_report_output_volume ()
void | (*tp_cli_call_content_interface_audio_control_callback_for_report_input_volume) ()
void | (*tp_cli_call_content_interface_audio_control_callback_for_report_output_volume) ()
TpProxyPendingCall * | tp_cli_call_content_interface_dtmf_call_multiple_tones ()
TpProxyPendingCall * | tp_cli_call_content_interface_dtmf_call_start_tone ()
TpProxyPendingCall * | tp_cli_call_content_interface_dtmf_call_stop_tone ()
void | (*tp_cli_call_content_interface_dtmf_callback_for_multiple_tones) ()
void | (*tp_cli_call_content_interface_dtmf_callback_for_start_tone) ()
void | (*tp_cli_call_content_interface_dtmf_callback_for_stop_tone) ()
TpProxySignalConnection * | tp_cli_call_content_interface_dtmf_connect_to_sending_tones ()
TpProxySignalConnection * | tp_cli_call_content_interface_dtmf_connect_to_stopped_tones ()
TpProxySignalConnection * | tp_cli_call_content_interface_dtmf_connect_to_tones_deferred ()
void | (*tp_cli_call_content_interface_dtmf_signal_callback_sending_tones) ()
void | (*tp_cli_call_content_interface_dtmf_signal_callback_stopped_tones) ()
void | (*tp_cli_call_content_interface_dtmf_signal_callback_tones_deferred) ()

## Includes

    #include <telepathy-glib/telepathy-glib-dbus.h>

## Description

Represents the contents of a call.

## Functions

### tp_cli_call_content_call_remove ()

    TpProxyPendingCall *
    tp_cli_call_content_call_remove (TpCallContent *proxy,
                                     gint timeout_ms,
                                     tp_cli_call_content_callback_for_remove callback,
                                     gpointer user_data,
                                     GDestroyNotify destroy,
                                     GObject *weak_object);

Start a Remove method call.

Remove the content from the call. This will cause <tp:dbus-ref namespace="ofdT.Channel.Type">Call1.ContentRemoved</tp:dbus-ref>((self_handle, <tp:value-ref type="Call_State_Change_Reason">User_Requested</tp:value-ref>, "", "")) to be emitted.

#### Parameters

proxy | the TpProxy |
timeout_ms | the timeout in milliseconds, or -1 to use the default |
callback | called when the method call succeeds or fails; may be `NULL` to make a "fire and forget" call with no reply tracking |
user_data | user-supplied data passed to the callback; must be `NULL` if `callback` is `NULL` |
destroy | called with the user_data as argument, after the call has succeeded, failed or been cancelled; must be `NULL` if `callback` is `NULL` |
weak_object | If not `NULL`, a GObject which will be weakly referenced; if it is destroyed, this call will automatically be cancelled. Must be `NULL` if `callback` is `NULL` |

#### Returns

a TpProxyPendingCall representing the call in progress. It is borrowed from the object, and will become invalid when the callback is called, the call is cancelled or the TpProxy becomes invalid.

### tp_cli_call_content_callback_for_remove ()

    void
    (*tp_cli_call_content_callback_for_remove)
                                   (TpCallContent *proxy,
                                    const GError *error,
                                    gpointer user_data,
                                    GObject *weak_object);

Signature of the callback called when a Remove method call succeeds or fails.

#### Parameters

proxy | the proxy on which the call was made |
error | `NULL` on success, or an error on failure |
user_data | user-supplied data |
weak_object | user-supplied object |

### tp_cli_call_content_connect_to_streams_added ()

    TpProxySignalConnection *
    tp_cli_call_content_connect_to_streams_added
                                   (TpCallContent *proxy,
                                    tp_cli_call_content_signal_callback_streams_added callback,
                                    gpointer user_data,
                                    GDestroyNotify destroy,
                                    GObject *weak_object,
                                    GError **error);

Connect a handler to the signal StreamsAdded.

<tp:docstring xmlns="http://www.w3.org/1999/xhtml"> <p>Emitted when streams are added to a call.</p>

#### Parameters

proxy | A TpCallContent or subclass |
callback | Callback to be called when the signal is received |
user_data | User-supplied data for the callback |
destroy | Destructor for the user-supplied data, which will be called when this signal is disconnected, or before this function returns `NULL` |
weak_object | A GObject which will be weakly referenced; if it is destroyed, this callback will automatically be disconnected |
error | If not `NULL`, used to raise an error if `NULL` is returned |

#### Returns

a TpProxySignalConnection containing all of the above, which can be used to disconnect the signal; or `NULL` if the proxy does not have the desired interface or has become invalid.

### tp_cli_call_content_connect_to_streams_removed ()

    TpProxySignalConnection *
    tp_cli_call_content_connect_to_streams_removed
                                   (TpCallContent *proxy,
                                    tp_cli_call_content_signal_callback_streams_removed callback,
                                    gpointer user_data,
                                    GDestroyNotify destroy,
                                    GObject *weak_object,
                                    GError **error);

Connect a handler to the signal StreamsRemoved.

<tp:docstring xmlns="http://www.w3.org/1999/xhtml"> <p>Emitted when streams are removed from a call</p>

#### Parameters

proxy | A TpCallContent or subclass |
callback | Callback to be called when the signal is received |
user_data | User-supplied data for the callback |
destroy | Destructor for the user-supplied data, which will be called when this signal is disconnected, or before this function returns `NULL` |
weak_object | A GObject which will be weakly referenced; if it is destroyed, this callback will automatically be disconnected |
error | If not `NULL`, used to raise an error if `NULL` is returned |

#### Returns

a TpProxySignalConnection containing all of the above, which can be used to disconnect the signal; or `NULL` if the proxy does not have the desired interface or has become invalid.

### tp_cli_call_content_signal_callback_streams_added ()

    void
    (*tp_cli_call_content_signal_callback_streams_added)
                                   (TpCallContent *proxy,
                                    const GPtrArray *arg_Streams,
                                    gpointer user_data,
                                    GObject *weak_object);

Represents the signature of a callback for the signal StreamsAdded.

#### Parameters

proxy | The proxy on which `tp_cli_call_content_connect_to_streams_added()` was called |
arg_Streams | The <tp:dbus-ref namespace="ofdT.Call1">Stream</tp:dbus-ref>s which were added. |
user_data | User-supplied data |
weak_object | User-supplied weakly referenced object |

### tp_cli_call_content_signal_callback_streams_removed ()

    void
    (*tp_cli_call_content_signal_callback_streams_removed)
                                   (TpCallContent *proxy,
                                    const GPtrArray *arg_Streams,
                                    const GValueArray *arg_Reason,
                                    gpointer user_data,
                                    GObject *weak_object);

Represents the signature of a callback for the signal StreamsRemoved.

#### Parameters

proxy | The proxy on which `tp_cli_call_content_connect_to_streams_removed()` was called |
arg_Streams | The <tp:dbus-ref namespace="ofdT.Call1">Stream</tp:dbus-ref>s which were removed. |
arg_Reason | Why the content was removed. |
user_data | User-supplied data |
weak_object | User-supplied weakly referenced object |

### tp_cli_call_content_interface_media_call_acknowledge_dtmf_change ()

    TpProxyPendingCall *
    tp_cli_call_content_interface_media_call_acknowledge_dtmf_change
                                   (TpCallContent *proxy,
                                    gint timeout_ms,
                                    guchar in_Event,
                                    guint in_State,
                                    tp_cli_call_content_interface_media_callback_for_acknowledge_dtmf_change callback,
                                    gpointer user_data,
                                    GDestroyNotify destroy,
                                    GObject *weak_object);

Start a AcknowledgeDTMFChange method call.

Called by the streaming implementation in response to <tp:member-ref>DTMFChangeRequested</tp:member-ref> to confirm that it has started or stopped sending the event in question.

#### Parameters

proxy | the TpProxy |
timeout_ms | the timeout in milliseconds, or -1 to use the default |
in_Event | Used to pass an 'in' argument: The event referred to in the corresponding <tp:member-ref>DTMFChangeRequested</tp:member-ref> signal. |
in_State | Used to pass an 'in' argument: Either <tp:value-ref type="Sending_State">Sending</tp:value-ref> or <tp:value-ref type="Sending_State">None</tp:value-ref>. (TpSendingState) |
callback | called when the method call succeeds or fails; may be `NULL` to make a "fire and forget" call with no reply tracking |
user_data | user-supplied data passed to the callback; must be `NULL` if `callback` is `NULL` |
destroy | called with the user_data as argument, after the call has succeeded, failed or been cancelled; must be `NULL` if `callback` is `NULL` |
weak_object | If not `NULL`, a GObject which will be weakly referenced; if it is destroyed, this call will automatically be cancelled. Must be `NULL` if `callback` is `NULL` |

#### Returns

a TpProxyPendingCall representing the call in progress. It is borrowed from the object, and will become invalid when the callback is called, the call is cancelled or the TpProxy becomes invalid.

### tp_cli_call_content_interface_media_call_fail ()

    TpProxyPendingCall *
    tp_cli_call_content_interface_media_call_fail
                                   (TpCallContent *proxy,
                                    gint timeout_ms,
                                    const GValueArray *in_Reason,
                                    tp_cli_call_content_interface_media_callback_for_fail callback,
                                    gpointer user_data,
                                    GDestroyNotify destroy,
                                    GObject *weak_object);

Start a Fail method call.

Signal an unrecoverable error for this content, and remove it.

#### Parameters

proxy | the TpProxy |
timeout_ms | the timeout in milliseconds, or -1 to use the default |
in_Reason | Used to pass an 'in' argument: A reason struct describing the error. |
callback | called when the method call succeeds or fails; may be `NULL` to make a "fire and forget" call with no reply tracking |
user_data | user-supplied data passed to the callback; must be `NULL` if `callback` is `NULL` |
destroy | called with the user_data as argument, after the call has succeeded, failed or been cancelled; must be `NULL` if `callback` is `NULL` |
weak_object | If not `NULL`, a GObject which will be weakly referenced; if it is destroyed, this call will automatically be cancelled. Must be `NULL` if `callback` is `NULL` |

#### Returns

a TpProxyPendingCall representing the call in progress. It is borrowed from the object, and will become invalid when the callback is called, the call is cancelled or the TpProxy becomes invalid.

### tp_cli_call_content_interface_media_call_update_local_media_description ()

    TpProxyPendingCall *
    tp_cli_call_content_interface_media_call_update_local_media_description
                                   (TpCallContent *proxy,
                                    gint timeout_ms,
                                    GHashTable *in_MediaDescription,
                                    tp_cli_call_content_interface_media_callback_for_update_local_media_description callback,
                                    gpointer user_data,
                                    GDestroyNotify destroy,
                                    GObject *weak_object);

Start a UpdateLocalMediaDescription method call.

Update the local codec mapping and other interfaces of the MediaDescription. This method should only be used during an existing call to update the local media description. This may trigger a re-negotiation which may result in new new MediaDescriptionOffers if the "FurtherNegotiationRequired" property is TRUE. Otherwise, only parameters which strictly describe the media being sent can be changed.

#### Parameters

proxy | the TpProxy |
timeout_ms | the timeout in milliseconds, or -1 to use the default |
in_MediaDescription | Used to pass an 'in' argument: The updated media description that the local side wants to use. |
callback | called when the method call succeeds or fails; may be `NULL` to make a "fire and forget" call with no reply tracking |
user_data | user-supplied data passed to the callback; must be `NULL` if `callback` is `NULL` |
destroy | called with the user_data as argument, after the call has succeeded, failed or been cancelled; must be `NULL` if `callback` is `NULL` |
weak_object | If not `NULL`, a GObject which will be weakly referenced; if it is destroyed, this call will automatically be cancelled. Must be `NULL` if `callback` is `NULL` |

#### Returns

a TpProxyPendingCall representing the call in progress. It is borrowed from the object, and will become invalid when the callback is called, the call is cancelled or the TpProxy becomes invalid.

### tp_cli_call_content_interface_media_callback_for_acknowledge_dtmf_change ()

    void
    (*tp_cli_call_content_interface_media_callback_for_acknowledge_dtmf_change)
                                   (TpCallContent *proxy,
                                    const GError *error,
                                    gpointer user_data,
                                    GObject *weak_object);

Signature of the callback called when a AcknowledgeDTMFChange method call succeeds or fails.

#### Parameters

proxy | the proxy on which the call was made |
error | `NULL` on success, or an error on failure |
user_data | user-supplied data |
weak_object | user-supplied object |

### tp_cli_call_content_interface_media_callback_for_fail ()

    void
    (*tp_cli_call_content_interface_media_callback_for_fail)
                                   (TpCallContent *proxy,
                                    const GError *error,
                                    gpointer user_data,
                                    GObject *weak_object);

Signature of the callback called when a Fail method call succeeds or fails.

#### Parameters

proxy | the proxy on which the call was made |
error | `NULL` on success, or an error on failure |
user_data | user-supplied data |
weak_object | user-supplied object |

### tp_cli_call_content_interface_media_callback_for_update_local_media_description ()

    void
    (*tp_cli_call_content_interface_media_callback_for_update_local_media_description)
                                   (TpCallContent *proxy,
                                    const GError *error,
                                    gpointer user_data,
                                    GObject *weak_object);

Signature of the callback called when a UpdateLocalMediaDescription method call succeeds or fails.

#### Parameters

proxy | the proxy on which the call was made |
error | `NULL` on success, or an error on failure |
user_data | user-supplied data |
weak_object | user-supplied object |

### tp_cli_call_content_interface_media_connect_to_dtmf_change_requested ()

    TpProxySignalConnection *
    tp_cli_call_content_interface_media_connect_to_dtmf_change_requested
                                   (TpCallContent *proxy,
                                    tp_cli_call_content_interface_media_signal_callback_dtmf_change_requested callback,
                                    gpointer user_data,
                                    GDestroyNotify destroy,
                                    GObject *weak_object,
                                    GError **error);

Connect a handler to the signal DTMFChangeRequested.

Used by the CM to relay instructions from <tp:dbus-ref namespace="ofdT">Channel.Interface.DTMF</tp:dbus-ref> to the streaming implementation. If any contact in this call supports the telephone-event codec in their MediaDescription, this event should be sent as outlined in RFC 4733. Otherwise, it should be sent as an audible tone.

#### Parameters

proxy | A TpCallContent or subclass |
callback | Callback to be called when the signal is received |
user_data | User-supplied data for the callback |
destroy | Destructor for the user-supplied data, which will be called when this signal is disconnected, or before this function returns `NULL` |
weak_object | A GObject which will be weakly referenced; if it is destroyed, this callback will automatically be disconnected |
error | If not `NULL`, used to raise an error if `NULL` is returned |

#### Returns

a TpProxySignalConnection containing all of the above, which can be used to disconnect the signal; or `NULL` if the proxy does not have the desired interface or has become invalid.

### tp_cli_call_content_interface_media_connect_to_local_media_description_changed ()

    TpProxySignalConnection *
    tp_cli_call_content_interface_media_connect_to_local_media_description_changed
                                   (TpCallContent *proxy,
                                    tp_cli_call_content_interface_media_signal_callback_local_media_description_changed callback,
                                    gpointer user_data,
                                    GDestroyNotify destroy,
                                    GObject *weak_object,
                                    GError **error);

Connect a handler to the signal LocalMediaDescriptionChanged.

<tp:docstring xmlns="http://www.w3.org/1999/xhtml"> <p>Change notification for <tp:dbus-ref namespace="ofdT.Call1.Content.Interface.Media">LocalMediaDescriptions</tp:dbus-ref> </p>

#### Parameters

proxy | A TpCallContent or subclass |
callback | Callback to be called when the signal is received |
user_data | User-supplied data for the callback |
destroy | Destructor for the user-supplied data, which will be called when this signal is disconnected, or before this function returns `NULL` |
weak_object | A GObject which will be weakly referenced; if it is destroyed, this callback will automatically be disconnected |
error | If not `NULL`, used to raise an error if `NULL` is returned |

#### Returns

a TpProxySignalConnection containing all of the above, which can be used to disconnect the signal; or `NULL` if the proxy does not have the desired interface or has become invalid.

### tp_cli_call_content_interface_media_connect_to_media_description_offer_done ()

    TpProxySignalConnection *
    tp_cli_call_content_interface_media_connect_to_media_description_offer_done
                                   (TpCallContent *proxy,
                                    tp_cli_call_content_interface_media_signal_callback_media_description_offer_done callback,
                                    gpointer user_data,
                                    GDestroyNotify destroy,
                                    GObject *weak_object,
                                    GError **error);

Connect a handler to the signal MediaDescriptionOfferDone.

<tp:docstring xmlns="http://www.w3.org/1999/xhtml"> <p>Emitted when a <tp:dbus-ref namespace="ofdT.Call1.Content">MediaDescription</tp:dbus-ref> has been handled. </p> <p>Emission of this signal indicates that the <tp:member-ref>MediaDescriptionOffer</tp:member-ref> property has changed to <code>("/", 0, {})</code>.</p>

#### Parameters

proxy | A TpCallContent or subclass |
callback | Callback to be called when the signal is received |
user_data | User-supplied data for the callback |
destroy | Destructor for the user-supplied data, which will be called when this signal is disconnected, or before this function returns `NULL` |
weak_object | A GObject which will be weakly referenced; if it is destroyed, this callback will automatically be disconnected |
error | If not `NULL`, used to raise an error if `NULL` is returned |

#### Returns

a TpProxySignalConnection containing all of the above, which can be used to disconnect the signal; or `NULL` if the proxy does not have the desired interface or has become invalid.

### tp_cli_call_content_interface_media_connect_to_media_descriptions_removed ()

    TpProxySignalConnection *
    tp_cli_call_content_interface_media_connect_to_media_descriptions_removed
                                   (TpCallContent *proxy,
                                    tp_cli_call_content_interface_media_signal_callback_media_descriptions_removed callback,
                                    gpointer user_data,
                                    GDestroyNotify destroy,
                                    GObject *weak_object,
                                    GError **error);

Connect a handler to the signal MediaDescriptionsRemoved.

<tp:docstring xmlns="http://www.w3.org/1999/xhtml"> <p>Removal notification for <tp:dbus-ref namespace="ofdT.Call1.Content.Interface.Media">RemoteMediaDescriptions</tp:dbus-ref> and <tp:dbus-ref namespace="ofdT.Call1.Content.Interface.Media">LocalMediaDescriptions</tp:dbus-ref> </p>

#### Parameters

proxy | A TpCallContent or subclass |
callback | Callback to be called when the signal is received |
user_data | User-supplied data for the callback |
destroy | Destructor for the user-supplied data, which will be called when this signal is disconnected, or before this function returns `NULL` |
weak_object | A GObject which will be weakly referenced; if it is destroyed, this callback will automatically be disconnected |
error | If not `NULL`, used to raise an error if `NULL` is returned |

#### Returns

a TpProxySignalConnection containing all of the above, which can be used to disconnect the signal; or `NULL` if the proxy does not have the desired interface or has become invalid.

### tp_cli_call_content_interface_media_connect_to_new_media_description_offer ()

    TpProxySignalConnection *
    tp_cli_call_content_interface_media_connect_to_new_media_description_offer
                                   (TpCallContent *proxy,
                                    tp_cli_call_content_interface_media_signal_callback_new_media_description_offer callback,
                                    gpointer user_data,
                                    GDestroyNotify destroy,
                                    GObject *weak_object,
                                    GError **error);

Connect a handler to the signal NewMediaDescriptionOffer.

<tp:docstring xmlns="http://www.w3.org/1999/xhtml"> <p>Emitted when a new <tp:dbus-ref namespace="ofdT.Call1.Content">MediaDescription</tp:dbus-ref> appears. The streaming &gt;implementation MUST respond by calling the <tp:dbus-ref namespace="ofdT.Call1.Content.MediaDescription">Accept</tp:dbus-ref> or <tp:dbus-ref namespace="ofdT.Call1.Content.MediaDescription">Reject</tp:dbus-ref> method on the description object appeared.</p> <p>Emission of this signal indicates that the <tp:member-ref>MediaDescriptionOffer</tp:member-ref> property has changed to <code>(Description, Contact, MediaDescriptionProperties)</code>.</p> <p>When the MediaDescriptionOffer has been dealt with then <tp:dbus-ref namespace="ofdT.Call1.Content.Interface.Media">MediaDescriptionOfferDone</tp:dbus-ref> must be emitted before <tp:dbus-ref namespace="ofdT.Call1.Content.Interface.Media">NewMediaDescriptionOffer</tp:dbus-ref> is emitted again. </p>

#### Parameters

proxy | A TpCallContent or subclass |
callback | Callback to be called when the signal is received |
user_data | User-supplied data for the callback |
destroy | Destructor for the user-supplied data, which will be called when this signal is disconnected, or before this function returns `NULL` |
weak_object | A GObject which will be weakly referenced; if it is destroyed, this callback will automatically be disconnected |
error | If not `NULL`, used to raise an error if `NULL` is returned |

#### Returns

a TpProxySignalConnection containing all of the above, which can be used to disconnect the signal; or `NULL` if the proxy does not have the desired interface or has become invalid.

### tp_cli_call_content_interface_media_connect_to_remote_media_descriptions_changed ()

    TpProxySignalConnection *
    tp_cli_call_content_interface_media_connect_to_remote_media_descriptions_changed
                                   (TpCallContent *proxy,
                                    tp_cli_call_content_interface_media_signal_callback_remote_media_descriptions_changed callback,
                                    gpointer user_data,
                                    GDestroyNotify destroy,
                                    GObject *weak_object,
                                    GError **error);

Connect a handler to the signal RemoteMediaDescriptionsChanged.

<tp:docstring xmlns="http://www.w3.org/1999/xhtml"> <p>Change notification for <tp:dbus-ref namespace="ofdT.Call1.Content.Interface.Media">RemoteMediaDescriptions</tp:dbus-ref> </p>

#### Parameters

proxy | A TpCallContent or subclass |
callback | Callback to be called when the signal is received |
user_data | User-supplied data for the callback |
destroy | Destructor for the user-supplied data, which will be called when this signal is disconnected, or before this function returns `NULL` |
weak_object | A GObject which will be weakly referenced; if it is destroyed, this callback will automatically be disconnected |
error | If not `NULL`, used to raise an error if `NULL` is returned |

#### Returns

a TpProxySignalConnection containing all of the above, which can be used to disconnect the signal; or `NULL` if the proxy does not have the desired interface or has become invalid.

### tp_cli_call_content_interface_media_signal_callback_dtmf_change_requested ()

    void
    (*tp_cli_call_content_interface_media_signal_callback_dtmf_change_requested)
                                   (TpCallContent *proxy,
                                    guchar arg_Event,
                                    guint arg_State,
                                    gpointer user_data,
                                    GObject *weak_object);

Represents the signature of a callback for the signal DTMFChangeRequested.

#### Parameters

proxy | The proxy on which `tp_cli_call_content_interface_media_connect_to_dtmf_change_requested()` was called |
arg_Event | The event to send (or stop sending). |
arg_State | Either <tp:value-ref type="Sending_State">Pending_Send</tp:value-ref> or <tp:value-ref type="Sending_State">Pending_Stop_Sending</tp:value-ref>. (TpSendingState) |
user_data | User-supplied data |
weak_object | User-supplied weakly referenced object |

### tp_cli_call_content_interface_media_signal_callback_local_media_description_changed ()

    void
    (*tp_cli_call_content_interface_media_signal_callback_local_media_description_changed)
                                   (TpCallContent *proxy,
                                    GHashTable *arg_Updated_Media_Description,
                                    gpointer user_data,
                                    GObject *weak_object);

Represents the signature of a callback for the signal LocalMediaDescriptionChanged.

#### Parameters

proxy | The proxy on which `tp_cli_call_content_interface_media_connect_to_local_media_description_changed()` was called |
arg_Updated_Media_Description | <tp:docstring xmlns="http://www.w3.org/1999/xhtml"> <p>The local content description that was updated</p> |
user_data | User-supplied data |
weak_object | User-supplied weakly referenced object |

### tp_cli_call_content_interface_media_signal_callback_media_description_offer_done ()

    void
    (*tp_cli_call_content_interface_media_signal_callback_media_description_offer_done)
                                   (TpCallContent *proxy,
                                    gpointer user_data,
                                    GObject *weak_object);

Represents the signature of a callback for the signal MediaDescriptionOfferDone.

#### Parameters

proxy | The proxy on which `tp_cli_call_content_interface_media_connect_to_media_description_offer_done()` was called |
user_data | User-supplied data |
weak_object | User-supplied weakly referenced object |

### tp_cli_call_content_interface_media_signal_callback_media_descriptions_removed ()

    void
    (*tp_cli_call_content_interface_media_signal_callback_media_descriptions_removed)
                                   (TpCallContent *proxy,
                                    const GArray *arg_Removed_Media_Descriptions,
                                    gpointer user_data,
                                    GObject *weak_object);

Represents the signature of a callback for the signal MediaDescriptionsRemoved.

#### Parameters

proxy | The proxy on which `tp_cli_call_content_interface_media_connect_to_media_descriptions_removed()` was called |
arg_Removed_Media_Descriptions | <tp:docstring xmlns="http://www.w3.org/1999/xhtml"> <p>The local and remote content descriptions that are no longer part of this content</p> |
user_data | User-supplied data |
weak_object | User-supplied weakly referenced object |

### tp_cli_call_content_interface_media_signal_callback_new_media_description_offer ()

    void
    (*tp_cli_call_content_interface_media_signal_callback_new_media_description_offer)
                                   (TpCallContent *proxy,
                                    const gchar *arg_Media_Description,
                                    GHashTable *arg_Properties,
                                    gpointer user_data,
                                    GObject *weak_object);

Represents the signature of a callback for the signal NewMediaDescriptionOffer.

#### Parameters

proxy | The proxy on which `tp_cli_call_content_interface_media_connect_to_new_media_description_offer()` was called |
arg_Media_Description | The object path of the new media description. This replaces any previous media description. |
arg_Properties | The immutable properties of the remote media description. <tp:rationale> Having all the MediaDescription properties here saves a D-Bus round-trip - it shouldn't be necessary to get the properties from the MediaDescription object, in practice. </tp:rationale> |
user_data | User-supplied data |
weak_object | User-supplied weakly referenced object |

### tp_cli_call_content_interface_media_signal_callback_remote_media_descriptions_changed ()

    void
    (*tp_cli_call_content_interface_media_signal_callback_remote_media_descriptions_changed)
                                   (TpCallContent *proxy,
                                    GHashTable *arg_Updated_Media_Descriptions,
                                    gpointer user_data,
                                    GObject *weak_object);

Represents the signature of a callback for the signal RemoteMediaDescriptionsChanged.

#### Parameters

proxy | The proxy on which `tp_cli_call_content_interface_media_connect_to_remote_media_descriptions_changed()` was called |
arg_Updated_Media_Descriptions | <tp:docstring xmlns="http://www.w3.org/1999/xhtml"> <p>The remote content descriptions that were updated</p> |
user_data | User-supplied data |
weak_object | User-supplied weakly referenced object |

### tp_cli_call_content_interface_video_control_connect_to_bitrate_changed ()

    TpProxySignalConnection *
    tp_cli_call_content_interface_video_control_connect_to_bitrate_changed
                                   (TpCallContent *proxy,
                                    tp_cli_call_content_interface_video_control_signal_callback_bitrate_changed callback,
                                    gpointer user_data,
                                    GDestroyNotify destroy,
                                    GObject *weak_object,
                                    GError **error);

Connect a handler to the signal BitrateChanged.

The desired bitrate has changed

#### Parameters

proxy | A TpCallContent or subclass |
callback | Callback to be called when the signal is received |
user_data | User-supplied data for the callback |
destroy | Destructor for the user-supplied data, which will be called when this signal is disconnected, or before this function returns `NULL` |
weak_object | A GObject which will be weakly referenced; if it is destroyed, this callback will automatically be disconnected |
error | If not `NULL`, used to raise an error if `NULL` is returned |

#### Returns

a TpProxySignalConnection containing all of the above, which can be used to disconnect the signal; or `NULL` if the proxy does not have the desired interface or has become invalid.

### tp_cli_call_content_interface_video_control_connect_to_framerate_changed ()

    TpProxySignalConnection *
    tp_cli_call_content_interface_video_control_connect_to_framerate_changed
                                   (TpCallContent *proxy,
                                    tp_cli_call_content_interface_video_control_signal_callback_framerate_changed callback,
                                    gpointer user_data,
                                    GDestroyNotify destroy,
                                    GObject *weak_object,
                                    GError **error);

Connect a handler to the signal FramerateChanged.

The desired framerate has changed

#### Parameters

proxy | A TpCallContent or subclass |
callback | Callback to be called when the signal is received |
user_data | User-supplied data for the callback |
destroy | Destructor for the user-supplied data, which will be called when this signal is disconnected, or before this function returns `NULL` |
weak_object | A GObject which will be weakly referenced; if it is destroyed, this callback will automatically be disconnected |
error | If not `NULL`, used to raise an error if `NULL` is returned |

#### Returns

a TpProxySignalConnection containing all of the above, which can be used to disconnect the signal; or `NULL` if the proxy does not have the desired interface or has become invalid.

### tp_cli_call_content_interface_video_control_connect_to_key_frame_requested ()

    TpProxySignalConnection *
    tp_cli_call_content_interface_video_control_connect_to_key_frame_requested
                                   (TpCallContent *proxy,
                                    tp_cli_call_content_interface_video_control_signal_callback_key_frame_requested callback,
                                    gpointer user_data,
                                    GDestroyNotify destroy,
                                    GObject *weak_object,
                                    GError **error);

Connect a handler to the signal KeyFrameRequested.

Request that the video encoder produce a new key frame as soon as possible.

#### Parameters

proxy | A TpCallContent or subclass |
callback | Callback to be called when the signal is received |
user_data | User-supplied data for the callback |
destroy | Destructor for the user-supplied data, which will be called when this signal is disconnected, or before this function returns `NULL` |
weak_object | A GObject which will be weakly referenced; if it is destroyed, this callback will automatically be disconnected |
error | If not `NULL`, used to raise an error if `NULL` is returned |

#### Returns

a TpProxySignalConnection containing all of the above, which can be used to disconnect the signal; or `NULL` if the proxy does not have the desired interface or has become invalid.

### tp_cli_call_content_interface_video_control_connect_to_mtu_changed ()

    TpProxySignalConnection *
    tp_cli_call_content_interface_video_control_connect_to_mtu_changed
                                   (TpCallContent *proxy,
                                    tp_cli_call_content_interface_video_control_signal_callback_mtu_changed callback,
                                    gpointer user_data,
                                    GDestroyNotify destroy,
                                    GObject *weak_object,
                                    GError **error);

Connect a handler to the signal MTUChanged.

The Maximum Transmission Unit has changed

#### Parameters

proxy | A TpCallContent or subclass |
callback | Callback to be called when the signal is received |
user_data | User-supplied data for the callback |
destroy | Destructor for the user-supplied data, which will be called when this signal is disconnected, or before this function returns `NULL` |
weak_object | A GObject which will be weakly referenced; if it is destroyed, this callback will automatically be disconnected |
error | If not `NULL`, used to raise an error if `NULL` is returned |

#### Returns

a TpProxySignalConnection containing all of the above, which can be used to disconnect the signal; or `NULL` if the proxy does not have the desired interface or has become invalid.

### tp_cli_call_content_interface_video_control_connect_to_video_resolution_changed ()

    TpProxySignalConnection *
    tp_cli_call_content_interface_video_control_connect_to_video_resolution_changed
                                   (TpCallContent *proxy,
                                    tp_cli_call_content_interface_video_control_signal_callback_video_resolution_changed callback,
                                    gpointer user_data,
                                    GDestroyNotify destroy,
                                    GObject *weak_object,
                                    GError **error);

Connect a handler to the signal VideoResolutionChanged.

The desired video resolution has changed.

#### Parameters

proxy | A TpCallContent or subclass |
callback | Callback to be called when the signal is received |
user_data | User-supplied data for the callback |
destroy | Destructor for the user-supplied data, which will be called when this signal is disconnected, or before this function returns `NULL` |
weak_object | A GObject which will be weakly referenced; if it is destroyed, this callback will automatically be disconnected |
error | If not `NULL`, used to raise an error if `NULL` is returned |

#### Returns

a TpProxySignalConnection containing all of the above, which can be used to disconnect the signal; or `NULL` if the proxy does not have the desired interface or has become invalid.

### tp_cli_call_content_interface_video_control_signal_callback_bitrate_changed ()

    void
    (*tp_cli_call_content_interface_video_control_signal_callback_bitrate_changed)
                                   (TpCallContent *proxy,
                                    guint arg_NewBitrate,
                                    gpointer user_data,
                                    GObject *weak_object);

Represents the signature of a callback for the signal BitrateChanged.

#### Parameters

proxy | The proxy on which `tp_cli_call_content_interface_video_control_connect_to_bitrate_changed()` was called |
arg_NewBitrate | . | [Undocumented]
user_data | User-supplied data |
weak_object | User-supplied weakly referenced object |

### tp_cli_call_content_interface_video_control_signal_callback_framerate_changed ()

    void
    (*tp_cli_call_content_interface_video_control_signal_callback_framerate_changed)
                                   (TpCallContent *proxy,
                                    guint arg_NewFramerate,
                                    gpointer user_data,
                                    GObject *weak_object);

Represents the signature of a callback for the signal FramerateChanged.

#### Parameters

proxy | The proxy on which `tp_cli_call_content_interface_video_control_connect_to_framerate_changed()` was called |
arg_NewFramerate | . | [Undocumented]
user_data | User-supplied data |
weak_object | User-supplied weakly referenced object |

### tp_cli_call_content_interface_video_control_signal_callback_key_frame_requested ()

    void
    (*tp_cli_call_content_interface_video_control_signal_callback_key_frame_requested)
                                   (TpCallContent *proxy,
                                    gpointer user_data,
                                    GObject *weak_object);

Represents the signature of a callback for the signal KeyFrameRequested.

#### Parameters

proxy | The proxy on which `tp_cli_call_content_interface_video_control_connect_to_key_frame_requested()` was called |
user_data | User-supplied data |
weak_object | User-supplied weakly referenced object |

### tp_cli_call_content_interface_video_control_signal_callback_mtu_changed ()

    void
    (*tp_cli_call_content_interface_video_control_signal_callback_mtu_changed)
                                   (TpCallContent *proxy,
                                    guint arg_NewMTU,
                                    gpointer user_data,
                                    GObject *weak_object);

Represents the signature of a callback for the signal MTUChanged.

#### Parameters

proxy | The proxy on which `tp_cli_call_content_interface_video_control_connect_to_mtu_changed()` was called |
arg_NewMTU | . | [Undocumented]
user_data | User-supplied data |
weak_object | User-supplied weakly referenced object |

### tp_cli_call_content_interface_video_control_signal_callback_video_resolution_changed ()

    void
    (*tp_cli_call_content_interface_video_control_signal_callback_video_resolution_changed)
                                   (TpCallContent *proxy,
                                    const GValueArray *arg_NewResolution,
                                    gpointer user_data,
                                    GObject *weak_object);

Represents the signature of a callback for the signal VideoResolutionChanged.

#### Parameters

proxy | The proxy on which `tp_cli_call_content_interface_video_control_connect_to_video_resolution_changed()` was called |
arg_NewResolution | . | [Undocumented]
user_data | User-supplied data |
weak_object | User-supplied weakly referenced object |

### tp_cli_call_content_interface_audio_control_call_report_input_volume ()

    TpProxyPendingCall *
    tp_cli_call_content_interface_audio_control_call_report_input_volume
                                   (TpCallContent *proxy,
                                    gint timeout_ms,
                                    gint in_Volume,
                                    tp_cli_call_content_interface_audio_control_callback_for_report_input_volume callback,
                                    gpointer user_data,
                                    GDestroyNotify destroy,
                                    GObject *weak_object);

Start a ReportInputVolume method call.

<p>Report to the CM that the Content input volume has been changed by the client.</p> <p>It is the client's responsibility to change the input volume used for the content. However, the client MUST call this whenever it changes input volume for the content.</p>

#### Parameters

proxy | the TpProxy |
timeout_ms | the timeout in milliseconds, or -1 to use the default |
in_Volume | Used to pass an 'in' argument: Report the input volume level as set by the client. |
callback | called when the method call succeeds or fails; may be `NULL` to make a "fire and forget" call with no reply tracking |
user_data | user-supplied data passed to the callback; must be `NULL` if `callback` is `NULL` |
destroy | called with the user_data as argument, after the call has succeeded, failed or been cancelled; must be `NULL` if `callback` is `NULL` |
weak_object | If not `NULL`, a GObject which will be weakly referenced; if it is destroyed, this call will automatically be cancelled. Must be `NULL` if `callback` is `NULL` |

#### Returns

a TpProxyPendingCall representing the call in progress. It is borrowed from the object, and will become invalid when the callback is called, the call is cancelled or the TpProxy becomes invalid.

### tp_cli_call_content_interface_audio_control_call_report_output_volume ()

    TpProxyPendingCall *
    tp_cli_call_content_interface_audio_control_call_report_output_volume
                                   (TpCallContent *proxy,
                                    gint timeout_ms,
                                    gint in_Volume,
                                    tp_cli_call_content_interface_audio_control_callback_for_report_output_volume callback,
                                    gpointer user_data,
                                    GDestroyNotify destroy,
                                    GObject *weak_object);

Start a ReportOutputVolume method call.

<p>Report to the CM that the content output volume has been changed by the client.</p> <p>It is the client's responsibility to change the output volume used for the content. However, the client MUST call this whenever it changes output volume for the content.</p>

#### Parameters

proxy | the TpProxy |
timeout_ms | the timeout in milliseconds, or -1 to use the default |
in_Volume | Used to pass an 'in' argument: Report the output volume level as set by the client. |
callback | called when the method call succeeds or fails; may be `NULL` to make a "fire and forget" call with no reply tracking |
user_data | user-supplied data passed to the callback; must be `NULL` if `callback` is `NULL` |
destroy | called with the user_data as argument, after the call has succeeded, failed or been cancelled; must be `NULL` if `callback` is `NULL` |
weak_object | If not `NULL`, a GObject which will be weakly referenced; if it is destroyed, this call will automatically be cancelled. Must be `NULL` if `callback` is `NULL` |

#### Returns

a TpProxyPendingCall representing the call in progress. It is borrowed from the object, and will become invalid when the callback is called, the call is cancelled or the TpProxy becomes invalid.

### tp_cli_call_content_interface_audio_control_callback_for_report_input_volume ()

    void
    (*tp_cli_call_content_interface_audio_control_callback_for_report_input_volume)
                                   (TpCallContent *proxy,
                                    const GError *error,
                                    gpointer user_data,
                                    GObject *weak_object);

Signature of the callback called when a ReportInputVolume method call succeeds or fails.

#### Parameters

proxy | the proxy on which the call was made |
error | `NULL` on success, or an error on failure |
user_data | user-supplied data |
weak_object | user-supplied object |

### tp_cli_call_content_interface_audio_control_callback_for_report_output_volume ()

    void
    (*tp_cli_call_content_interface_audio_control_callback_for_report_output_volume)
                                   (TpCallContent *proxy,
                                    const GError *error,
                                    gpointer user_data,
                                    GObject *weak_object);

Signature of the callback called when a ReportOutputVolume method call succeeds or fails.

#### Parameters

proxy | the proxy on which the call was made |
error | `NULL` on success, or an error on failure |
user_data | user-supplied data |
weak_object | user-supplied object |

### tp_cli_call_content_interface_dtmf_call_multiple_tones ()

    TpProxyPendingCall *
    tp_cli_call_content_interface_dtmf_call_multiple_tones
                                   (TpCallContent *proxy,
                                    gint timeout_ms,
                                    const gchar *in_Tones,
                                    tp_cli_call_content_interface_dtmf_callback_for_multiple_tones callback,
                                    gpointer user_data,
                                    GDestroyNotify destroy,
                                    GObject *weak_object);

Start a MultipleTones method call.

<p>Send multiple DTMF events to all eligible streams in the channel. Each tone will be played for an implementation-defined number of milliseconds (typically 250ms), followed by a gap before the next tone is played (typically 100ms). The duration and gap are defined by the protocol or connection manager.</p> <tp:rationale> <p>In cases where the client knows in advance the tone sequence it wants to send, it's easier to use this method than manually start and stop each tone in the sequence.</p> <p>The tone and gap lengths may need to vary for interoperability, according to the protocol and other implementations' ability to recognise tones. At the time of writing, GStreamer uses a minimum of 250ms tones and 100ms gaps when playing in-band DTMF in the normal audio stream, or 70ms tones and 50ms gaps when encoding DTMF as <code>audio/telephone-event</code>.</p> </tp:rationale> <p>Tone overlaping or queueing is not supported, so this method can only be called if no DTMF tones are already being played.</p>

#### Parameters

proxy | the TpProxy |
timeout_ms | the timeout in milliseconds, or -1 to use the default |

in_Tones

Used to pass an 'in' argument: <tp:docstring xmlns="http://www.w3.org/1999/xhtml"> <p>A string representation of one or more DTMF events. Implementations of this method MUST support all of the following characters in this string:</p> <ul> <li>the digits 0-9, letters A-D and a-d, and symbols '*' and '#' correspond to the members of <tp:type>DTMF_Event</tp:type></li> <li>any of 'p', 'P', 'x', 'X' or ',' (comma) results in an implementation-defined pause, typically for 3 seconds</li> <li>'w' or 'W' waits for the user to continue, by stopping interpretation of the string, and if there is more to be played, emitting the <tp:member-ref>TonesDeferred</tp:member-ref> signal with the rest of the string as its argument: see that signal for details</li> </ul>

callback | called when the method call succeeds or fails; may be `NULL` to make a "fire and forget" call with no reply tracking |
user_data | user-supplied data passed to the callback; must be `NULL` if `callback` is `NULL` |
destroy | called with the user_data as argument, after the call has succeeded, failed or been cancelled; must be `NULL` if `callback` is `NULL` |
weak_object | If not `NULL`, a GObject which will be weakly referenced; if it is destroyed, this call will automatically be cancelled. Must be `NULL` if `callback` is `NULL` |

#### Returns

a TpProxyPendingCall representing the call in progress. It is borrowed from the object, and will become invalid when the callback is called, the call is cancelled or the TpProxy becomes invalid.

### tp_cli_call_content_interface_dtmf_call_start_tone ()

    TpProxyPendingCall *
    tp_cli_call_content_interface_dtmf_call_start_tone
                                   (TpCallContent *proxy,
                                    gint timeout_ms,
                                    guchar in_Event,
                                    tp_cli_call_content_interface_dtmf_callback_for_start_tone callback,
                                    gpointer user_data,
                                    GDestroyNotify destroy,
                                    GObject *weak_object);

Start a StartTone method call.

<p>Start sending a DTMF tone to all eligible streams in the channel. Where possible, the tone will continue until <tp:member-ref>StopTone</tp:member-ref> is called. On certain protocols, it may only be possible to send events with a predetermined length. In this case, the implementation MAY emit a fixed-length tone, and the StopTone method call SHOULD return NotAvailable.</p> <tp:rationale> The client may wish to control the exact duration and timing of the tones sent as a result of user's interaction with the dialpad, thus starting and stopping the tone sending explicitly. </tp:rationale> <p>Tone overlaping or queueing is not supported, so this method can only be called if no DTMF tones are already being played.</p>

#### Parameters

proxy | the TpProxy |
timeout_ms | the timeout in milliseconds, or -1 to use the default |
in_Event | Used to pass an 'in' argument: A numeric event code from the DTMF_Event enum. |
callback | called when the method call succeeds or fails; may be `NULL` to make a "fire and forget" call with no reply tracking |
user_data | user-supplied data passed to the callback; must be `NULL` if `callback` is `NULL` |
destroy | called with the user_data as argument, after the call has succeeded, failed or been cancelled; must be `NULL` if `callback` is `NULL` |
weak_object | If not `NULL`, a GObject which will be weakly referenced; if it is destroyed, this call will automatically be cancelled. Must be `NULL` if `callback` is `NULL` |

#### Returns

a TpProxyPendingCall representing the call in progress. It is borrowed from the object, and will become invalid when the callback is called, the call is cancelled or the TpProxy becomes invalid.

### tp_cli_call_content_interface_dtmf_call_stop_tone ()

    TpProxyPendingCall *
    tp_cli_call_content_interface_dtmf_call_stop_tone
                                   (TpCallContent *proxy,
                                    gint timeout_ms,
                                    tp_cli_call_content_interface_dtmf_callback_for_stop_tone callback,
                                    gpointer user_data,
                                    GDestroyNotify destroy,
                                    GObject *weak_object);

Start a StopTone method call.

Stop sending any DTMF tones which have been started using the <tp:member-ref>StartTone</tp:member-ref> or <tp:member-ref>MultipleTones</tp:member-ref> methods. If there is no current tone, this method will do nothing. If MultipleTones was used, the client should not assume the sending has stopped immediately; instead, the client should wait for the StoppedTones signal. <tp:rationale> On some protocols it might be impossible to cancel queued tones immediately. </tp:rationale>

#### Parameters

proxy | the TpProxy |
timeout_ms | the timeout in milliseconds, or -1 to use the default |
callback | called when the method call succeeds or fails; may be `NULL` to make a "fire and forget" call with no reply tracking |
user_data | user-supplied data passed to the callback; must be `NULL` if `callback` is `NULL` |
destroy | called with the user_data as argument, after the call has succeeded, failed or been cancelled; must be `NULL` if `callback` is `NULL` |
weak_object | If not `NULL`, a GObject which will be weakly referenced; if it is destroyed, this call will automatically be cancelled. Must be `NULL` if `callback` is `NULL` |

#### Returns

a TpProxyPendingCall representing the call in progress. It is borrowed from the object, and will become invalid when the callback is called, the call is cancelled or the TpProxy becomes invalid.

### tp_cli_call_content_interface_dtmf_callback_for_multiple_tones ()

    void
    (*tp_cli_call_content_interface_dtmf_callback_for_multiple_tones)
                                   (TpCallContent *proxy,
                                    const GError *error,
                                    gpointer user_data,
                                    GObject *weak_object);

Signature of the callback called when a MultipleTones method call succeeds or fails.

#### Parameters

proxy | the proxy on which the call was made |
error | `NULL` on success, or an error on failure |
user_data | user-supplied data |
weak_object | user-supplied object |

### tp_cli_call_content_interface_dtmf_callback_for_start_tone ()

    void
    (*tp_cli_call_content_interface_dtmf_callback_for_start_tone)
                                   (TpCallContent *proxy,
                                    const GError *error,
                                    gpointer user_data,
                                    GObject *weak_object);

Signature of the callback called when a StartTone method call succeeds or fails.

#### Parameters

proxy | the proxy on which the call was made |
error | `NULL` on success, or an error on failure |
user_data | user-supplied data |
weak_object | user-supplied object |

### tp_cli_call_content_interface_dtmf_callback_for_stop_tone ()

    void
    (*tp_cli_call_content_interface_dtmf_callback_for_stop_tone)
                                   (TpCallContent *proxy,
                                    const GError *error,
                                    gpointer user_data,
                                    GObject *weak_object);

Signature of the callback called when a StopTone method call succeeds or fails.

#### Parameters

proxy | the proxy on which the call was made |
error | `NULL` on success, or an error on failure |
user_data | user-supplied data |
weak_object | user-supplied object |

### tp_cli_call_content_interface_dtmf_connect_to_sending_tones ()

    TpProxySignalConnection *
    tp_cli_call_content_interface_dtmf_connect_to_sending_tones
                                   (TpCallContent *proxy,
                                    tp_cli_call_content_interface_dtmf_signal_callback_sending_tones callback,
                                    gpointer user_data,
                                    GDestroyNotify destroy,
                                    GObject *weak_object,
                                    GError **error);

Connect a handler to the signal SendingTones.

<tp:docstring xmlns="http://www.w3.org/1999/xhtml"> <p>DTMF tone(s)are being sent to all eligible streams in the channel. The signal is provided to indicating the fact that the streams are currently being used to send one or more DTMF tones, so any other media input is not getting through to the audio stream. It also serves as a cue for the <tp:member-ref>StopTone</tp:member-ref> method.</p>

#### Parameters

proxy | A TpCallContent or subclass |
callback | Callback to be called when the signal is received |
user_data | User-supplied data for the callback |
destroy | Destructor for the user-supplied data, which will be called when this signal is disconnected, or before this function returns `NULL` |
weak_object | A GObject which will be weakly referenced; if it is destroyed, this callback will automatically be disconnected |
error | If not `NULL`, used to raise an error if `NULL` is returned |

#### Returns

a TpProxySignalConnection containing all of the above, which can be used to disconnect the signal; or `NULL` if the proxy does not have the desired interface or has become invalid.

### tp_cli_call_content_interface_dtmf_connect_to_stopped_tones ()

    TpProxySignalConnection *
    tp_cli_call_content_interface_dtmf_connect_to_stopped_tones
                                   (TpCallContent *proxy,
                                    tp_cli_call_content_interface_dtmf_signal_callback_stopped_tones callback,
                                    gpointer user_data,
                                    GDestroyNotify destroy,
                                    GObject *weak_object,
                                    GError **error);

Connect a handler to the signal StoppedTones.

<tp:docstring xmlns="http://www.w3.org/1999/xhtml"> <p>DTMF tones have finished playing on streams in this channel.</p>

#### Parameters

proxy | A TpCallContent or subclass |
callback | Callback to be called when the signal is received |
user_data | User-supplied data for the callback |
destroy | Destructor for the user-supplied data, which will be called when this signal is disconnected, or before this function returns `NULL` |
weak_object | A GObject which will be weakly referenced; if it is destroyed, this callback will automatically be disconnected |
error | If not `NULL`, used to raise an error if `NULL` is returned |

#### Returns

a TpProxySignalConnection containing all of the above, which can be used to disconnect the signal; or `NULL` if the proxy does not have the desired interface or has become invalid.

### tp_cli_call_content_interface_dtmf_connect_to_tones_deferred ()

    TpProxySignalConnection *
    tp_cli_call_content_interface_dtmf_connect_to_tones_deferred
                                   (TpCallContent *proxy,
                                    tp_cli_call_content_interface_dtmf_signal_callback_tones_deferred callback,
                                    gpointer user_data,
                                    GDestroyNotify destroy,
                                    GObject *weak_object,
                                    GError **error);

Connect a handler to the signal TonesDeferred.

<tp:docstring xmlns="http://www.w3.org/1999/xhtml"> <p>Emitted when 'w' or 'W', indicating "wait for the user to continue", is encountered while playing a DTMF string queued by <tp:member-ref>MultipleTones</tp:member-ref>. Any queued DTMF events after the 'w', which have not yet been played, are placed in the <tp:member-ref>DeferredTones</tp:member-ref> property and copied into this signal's argument.</p> <p>When the channel handler is ready to continue, it MAY pass the value of <tp:member-ref>DeferredTones</tp:member-ref> to <tp:member-ref>MultipleTones</tp:member-ref>, to resume sending. Alternatively, it MAY ignore the deferred tones, or even play different tones instead. Any deferred tones are discarded the next time a tone is played.</p> <p>This signal SHOULD NOT be emitted if there is nothing left to play, i.e. if the 'w' was the last character in the DTMF string.</p>

#### Parameters

proxy | A TpCallContent or subclass |
callback | Callback to be called when the signal is received |
user_data | User-supplied data for the callback |
destroy | Destructor for the user-supplied data, which will be called when this signal is disconnected, or before this function returns `NULL` |
weak_object | A GObject which will be weakly referenced; if it is destroyed, this callback will automatically be disconnected |
error | If not `NULL`, used to raise an error if `NULL` is returned |

#### Returns

a TpProxySignalConnection containing all of the above, which can be used to disconnect the signal; or `NULL` if the proxy does not have the desired interface or has become invalid.

### tp_cli_call_content_interface_dtmf_signal_callback_sending_tones ()

    void
    (*tp_cli_call_content_interface_dtmf_signal_callback_sending_tones)
                                   (TpCallContent *proxy,
                                    const gchar *arg_Tones,
                                    gpointer user_data,
                                    GObject *weak_object);

Represents the signature of a callback for the signal SendingTones.

#### Parameters

proxy | The proxy on which `tp_cli_call_content_interface_dtmf_connect_to_sending_tones()` was called |
arg_Tones | DTMF string (one or more events) that is to be played. |
user_data | User-supplied data |
weak_object | User-supplied weakly referenced object |

### tp_cli_call_content_interface_dtmf_signal_callback_stopped_tones ()

    void
    (*tp_cli_call_content_interface_dtmf_signal_callback_stopped_tones)
                                   (TpCallContent *proxy,
                                    gboolean arg_Cancelled,
                                    gpointer user_data,
                                    GObject *weak_object);

Represents the signature of a callback for the signal StoppedTones.

#### Parameters

proxy | The proxy on which `tp_cli_call_content_interface_dtmf_connect_to_stopped_tones()` was called |
arg_Cancelled | True if the DTMF tones were actively cancelled via <tp:member-ref>StopTone</tp:member-ref>. |
user_data | User-supplied data |
weak_object | User-supplied weakly referenced object |

### tp_cli_call_content_interface_dtmf_signal_callback_tones_deferred ()

    void
    (*tp_cli_call_content_interface_dtmf_signal_callback_tones_deferred)
                                   (TpCallContent *proxy,
                                    const gchar *arg_Tones,
                                    gpointer user_data,
                                    GObject *weak_object);

Represents the signature of a callback for the signal TonesDeferred.

#### Parameters

proxy | The proxy on which `tp_cli_call_content_interface_dtmf_connect_to_tones_deferred()` was called |
arg_Tones | The new non-empty value of <tp:member-ref>DeferredTones</tp:member-ref>. |
user_data | User-supplied data |
weak_object | User-supplied weakly referenced object |